#!/usr/bin/env python3
from collections import namedtuple

N, Q = [int(x) for x in input().split()]
nodes = [[999999 for i2 in range(N)] for i1 in range(N)]
for i in range(Q):
    innums = [int(x) for x in input().split()]
    if innums[0] == 0:
        nodes[innums[1]][innums[2]] = innums[3]
        nodes[innums[2]][innums[1]] = innums[3]
    if innums[0] == 1:
        nodes[innums[1]][innums[2]] = 99999
        nodes[innums[2]][innums[1]] = 99999
    if innums[0] == 2:
        for l in nodes:
            print("D1", " ".join(["X" if x > 99 else str(x) for x in l]))
        QPos = namedtuple("QPos", ["n", "val", "danger"])
        nodevals = [999999 for i in range(N)]
        queue = [QPos(innums[1], 0, 0)]
        targetnode = innums[2]
        solutions = []
        while len(queue) > 0:
            pos = queue.pop()
            if pos == targetnode:
                solutions.append(pos)
                continue
            for i, nextval in enumerate(nodes[pos.n]):
                if pos.val + nextval > nodevals[i]: continue
                danger = nextval if nextval > pos.danger else pos.danger
                queue.append(QPos(i, pos.val + nextval, danger))
        if len(solutions) == 0:
            print(-1)
        else:
            print(min([s.danger for s in solutions]))
